﻿#region copyright
// SabberStone, Hearthstone Simulator in C# .NET Core
// Copyright (C) 2017-2019 SabberStone Team, darkfriend77 & rnilva
//
// SabberStone is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License.
// SabberStone is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using SabberStoneCore.Model.Entities;
using SabberStoneCoreAi.src.Agent;
using SabberStoneCore.Enums;
using SabberStoneCoreAi.Competition.Agents;


namespace SabberStoneCoreAi.Score
{
	public class ScoreShaman : Score
	{
		public override int Rate()
		{
			
			POGame.POGame old = cState.getState();
			Controller pC = old.CurrentPlayer.Controller;
			Controller oC = pC.Opponent;

			if (OpHeroHp < 1)
				return Int32.MaxValue;

			if (HeroHp < 1)
				return Int32.MinValue;

			int result = 0;

			if (OpBoardZone.Count == 0 && BoardZone.Count > 0)
				result += 5000;
			
			result += Controller.HeroPowerActivationsThisTurn * 10;

			if (OpMinionTotHealthTaunt > 0)
				result += OpMinionTotHealthTaunt * -500;
			
			result += Controller.OverloadOwed * -20;

			if(Controller.Opponent.HeroClass.Equals(CardClass.MAGE)){
				result += (oC.Hero.Health - OpHeroHp) * 10;

				result += Controller.HandZone.Count * 25;

				result -= (pC.Hero.Health - HeroHp) * 5;

				result += (BoardZone.Count - OpBoardZone.Count) * 10;

				result += (MinionTotHealth - OpMinionTotHealth) * 30;

				result += (MinionTotAtk - OpMinionTotAtk) * 30;

				if(OpHeroHp <= 5 )
					result += OpHeroHp * -20;
			}else{
				
				result += Controller.HandZone.Count * 0;

				result += (oC.Hero.Health - OpHeroHp) * 10;

				result -= (pC.Hero.Health - HeroHp) * 10;

				result += (BoardZone.Count - OpBoardZone.Count) * 15;

				result += (MinionTotHealth - OpMinionTotHealth) * 30;

				result += MinionTotAtk * 10;
				result += (MinionTotAtk - OpMinionTotAtk) * 30;
			}

			return result;
		}

		public override Func<List<IPlayable>, List<int>> MulliganRule()
		{
			return p => p.Where(t => t.Cost > 3).Select(t => t.Id).ToList();
		}
	}
}
